#include "PD_NodeUpdate.h"
#include "glog/logging.h"

using namespace ADC;
using namespace ADC::PD_NodeUpdate;

void NodeUpdate::ResDurationHVInfo(const PD_EgoVehTrj::EgoVehTrj &egovehtrj,
                                   const PD::PD_Input &pd_input)

{

    std::vector<int> hvinfo_idx;
    // mpc_drv_msgs::msg::HVInfo nodehvinfo;
    bool _nodeinitFlag = true;

    _nodeinitFlag = _nodeinitFlag && (!egovehtrj.egoveh_tp.empty()); // check egoveh trajectyro point

    // get current EgoLane id
    uint8_t _cur_EgoLaneId = 0;

    // std::cout << "Node_00" << std::endl;
    if (_nodeinitFlag == true)
    {
        float NodeResTm = egovehtrj.egoveh_tp.back().t;

        for (float i = 0.0f; i < NodeResTm + 0.001; i = i + 0.5)
        {
            int node_indx = static_cast<int>(10 * i);
            // hvinfo_idx.emplace_back(ceil(10 * i)); // get origianl index
            hvinfo_idx.emplace_back(node_indx);
        }

        for (int i = 0; i < hvinfo_idx.size(); i++)
        {

            pd_nodehvinfo.t = i * 0.5;

            // pd_nodehvinfo.relat_s = egovehtrj.egoveh_tp.at(hvinfo_idx.at(i)).s;

            if (pd_input.rm_roadmodel.at(rm_Num).road_id.x == static_cast<uint8_t>(0))
            {

                pd_nodehvinfo.relat_s = egovehtrj.egoveh_tp.at(hvinfo_idx.at(i)).s;
            }
            else
            {
                pd_nodehvinfo.relat_s = pd_input.rm_roadmodel.at(rm_Num).m_lastnode_s + egovehtrj.egoveh_tp.at(hvinfo_idx.at(i)).s;
            }

            pd_nodehvinfo.RELAT_S = egovehtrj.egoveh_tp.at(hvinfo_idx.at(i)).s;

            pd_nodehvinfo.re2ref_l = egovehtrj.egoveh_tp.at(hvinfo_idx.at(i)).l;

            pd_nodehvinfo.vx = egovehtrj.egoveh_tp.at(hvinfo_idx.at(i)).vx;

            pd_nodehvinfo.locationID = 0;

            nodehvinfo.emplace_back(pd_nodehvinfo);

            // std::cout << "pd_i: " << i << std::endl;
        }

        // float _temp_refC0 = 0.0f;

        _cur_EgoLaneId = pd_input.rm_roadmodel.at(rm_Num).car_position.ego_lane_id;
        // _cur_EgoLaneId = pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lm_

        std::vector<int> bdy_id_list; // to store related boundary_list id during lane change;

        std::vector<uint32_t> related_bdy_idlist; // to store related boundary_list id during lane change;

        refC0Info refc0info;

        // float P_PD_ChgLneLftCrosLneThrs = 0.1; // vehicle lane change left cross line threshold;
        // float P_PD_ChgLneRgtCrosLneThrs = 0.1;

        std::vector<uint8_t> LeftLaneID;
        std::vector<uint8_t> RightLaneID;

        // to get which corridor of lane refline--c0

        for (int id_idx = 0; id_idx < pd_input.rm_roadmodel.at(rm_Num).lane_list.size(); id_idx++) // to get lane number
        {

            if (_cur_EgoLaneId == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).start_id) // to get egolane id of each road model
            {

                // lane follow lane id update
                if (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type != BA::BA_ActionTyp::BA_ActionTyp_LeftLaneChange &&
                    pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type != BA::BA_ActionTyp::BA_ActionTyp_RightLaneChange) /// action type 2: leftChange ; action type 3: rightChange
                // if (lattrj.pd_LatTrj_EV_ActionType != 2 && lattrj.pd_LatTrj_EV_ActionType != 3)
                {
                    for (int idSize = 0; idSize < nodehvinfo.size(); idSize++)
                    {

                        nodehvinfo.at(idSize).locationID = pd_input.rm_roadmodel.at(rm_Num).car_position.ego_lane_id; // lane folow ego lane id

                        // std::cout << "action type 1!!!!!!!!!" << std::endl;
                    }
                }

                else
                { // Change left land id update
                    // if (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == 2 && !(pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).left_neighbor_lane.empty())) // Lane Change Left
                    if (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == BA::BA_ActionTyp::BA_ActionTyp_LeftLaneChange)
                    {
                        float LeftInitRefC0 = 0.0f;

                        // to get initial LeftInitRefC0 from the boundary

                        for (int lftlan_mkID_idx = 0; lftlan_mkID_idx < pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).left_lane_marker_id_list.size(); lftlan_mkID_idx++)
                        {
                            for (int lan_mk_idx = 0; lan_mk_idx < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.size(); lan_mk_idx++)
                            {
                                if (pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).left_lane_marker_id_list[lftlan_mkID_idx] == pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lan_mk_idx].id)
                                {
                                    if (!pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lan_mk_idx].front_lane_boundary_list.empty())
                                    {
                                        LeftInitRefC0 = fabs(pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lan_mk_idx].front_lane_boundary_list.front().line_geometry.c0);
                                    }

                                    // else
                                    // {

                                    //     LaneChgClsnFlag = true;
                                    // }
                                }
                            }
                        }

                        for (int i = 0; i < nodehvinfo.size(); i++)
                        {

                            // judge from RefEgoLane_re2ref_l and refC0;
                            if (LeftInitRefC0 >= fabs(fabs(nodehvinfo.front().re2ref_l) - fabs(nodehvinfo[i].re2ref_l)))
                            {
                                nodehvinfo.at(i).locationID = pd_input.rm_roadmodel.at(rm_Num).car_position.ego_lane_id;
                            }
                            else // update left split lane case lane id logic
                            {

                                // nodehvinfo.at(i).locationID = pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).left_neighbor_lane.front().lane_id;

                                if (pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).left_neighbor_lane.size() == 1)
                                {
                                    nodehvinfo.at(i).locationID = pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).left_neighbor_lane.front().lane_id;
                                }
                                else
                                {
                                    // select real left neighbor lane
                                    // 1.according to lgt dist to judge
                                    for (int m = 0; m < pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).left_neighbor_lane.size(); m++)
                                    {
                                        if (nodehvinfo.back().RELAT_S > pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).left_neighbor_lane[m].start_range &&
                                            nodehvinfo.back().RELAT_S < pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).left_neighbor_lane[m].end_range)

                                        {
                                            nodehvinfo.at(i).locationID = pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).left_neighbor_lane[m].lane_id;
                                        }
                                    }
                                }
                            }
                        }
                        // Change left Debounce Logic Protection

                        // Change left enforce Change lane id and match target corridor id

                        // check pd laned id match target corridor id of related lane id

                        uint8_t leftobjlaneid = 0;
                        leftobjlaneid = CorIDMatchLaneID(pd_input);
                        if (nodehvinfo.back().locationID != leftobjlaneid && leftobjlaneid != static_cast<uint8_t>(0))
                        {
                            nodehvinfo.back().locationID = leftobjlaneid;
                        }
                        int ChgLftIDChgTrgNum = 0;
                        // int ChgLftIDChgTrgNum_indx = 0;

                        for (int i = 0; i < nodehvinfo.size() - 1; i++)
                        {
                            if (nodehvinfo.at(i).locationID != nodehvinfo.at(i + 1).locationID)
                            {
                                ChgLftIDChgTrgNum = i + 1;
                                // ChgLftIDChgTrgNum_indx = i + 1;
                                break;
                            }
                        }
                        // update Lane id
                        for (int i = ChgLftIDChgTrgNum; i < nodehvinfo.size(); i++)
                        {
                            // nodehvinfo.at(i).locationID = pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).left_neighbor_lane.front().lane_id;
                            // nodehvinfo.at(i).locationID = nodehvinfo.at(ChgLftIDChgTrgNum_indx).locationID;
                            nodehvinfo.at(i).locationID = leftobjlaneid;
                        }
                    }

                    // Change right lane id update
                    // DLOG(INFO) << "pd_action_type: " << int(pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type) << std::endl;
                    // DLOG(INFO) << "rgt_neiglanesize: " << pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).right_neighbor_lane.size() << std::endl;
                    // if ((pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == 3) && (!pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).right_neighbor_lane.empty())) // Lane Change Right
                    if (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == BA::BA_ActionTyp::BA_ActionTyp_RightLaneChange)
                    {
                        float RightInitRefC0 = 0.0f;

                        // to get initial refC0 from the boundary

                        for (int rgtlan_mkID_idx = 0; rgtlan_mkID_idx < pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).right_lane_marker_id_list.size(); rgtlan_mkID_idx++)
                        {
                            for (int lan_mk_idx = 0; lan_mk_idx < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.size(); lan_mk_idx++)
                            {
                                if (pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).right_lane_marker_id_list[rgtlan_mkID_idx] == pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lan_mk_idx].id)
                                {
                                    if (!pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lan_mk_idx].front_lane_boundary_list.empty())
                                    {
                                        RightInitRefC0 = fabs(pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lan_mk_idx].front_lane_boundary_list.front().line_geometry.c0);
                                    }
                                    // else
                                    // {
                                    //     LaneChgClsnFlag = true;
                                    // }
                                }
                            }
                        }

                        for (int i = 0; i < nodehvinfo.size(); i++)
                        {
                            // RefEgoLane_re2ref_l.emplace_back(fabs(nodehvinfo.front().re2ref_l) - fabs(nodehvinfo[i].re2ref_l));

                            // judge from RefEgoLane_re2ref_l and refC0;
                            if (RightInitRefC0 >= fabs(fabs(nodehvinfo.front().re2ref_l) - fabs(nodehvinfo[i].re2ref_l)))
                            {
                                nodehvinfo.at(i).locationID = pd_input.rm_roadmodel.at(rm_Num).car_position.ego_lane_id;
                            }
                            else // update right split lane case lane id logic
                            {
                                if (pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).right_neighbor_lane.size() == 1)
                                {
                                    nodehvinfo.at(i).locationID = pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).right_neighbor_lane.front().lane_id;
                                }
                                else
                                {
                                    // select real right neighbor lane
                                    // 1.according to lgt dist to judge
                                    for (int m = 0; m < pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).right_neighbor_lane.size(); m++)
                                    {
                                        if (nodehvinfo.back().RELAT_S > pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).right_neighbor_lane[m].start_range &&
                                            nodehvinfo.back().RELAT_S < pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).right_neighbor_lane[m].end_range)
                                        {
                                            nodehvinfo.at(i).locationID = pd_input.rm_roadmodel.at(rm_Num).lane_list.at(id_idx).right_neighbor_lane[m].lane_id;
                                        }
                                    }
                                }
                            }
                        }
                        // Change right Debounce Logic Protection

                        // Change right enforce Change lane id

                        // check pd laned id match target corridor id of related lane id

                        uint8_t rightobjlaneid = 0;
                        rightobjlaneid = CorIDMatchLaneID(pd_input);
                        // DLOG(INFO) << "$$ R_objlanid: " << int(rightobjlaneid) << std::endl;
                        if (nodehvinfo.back().locationID != rightobjlaneid && (rightobjlaneid != static_cast<uint8_t>(0)))
                        {
                            nodehvinfo.back().locationID = rightobjlaneid;
                        }

                        int ChgRhtIDChgTrgNum = 0; // diferent lane id position indx
                        // int ChgRhtIDChgTrgNum_indx = 0;

                        for (int i = 0; i < nodehvinfo.size() - 1; i++)
                        {
                            if (nodehvinfo.at(i).locationID != nodehvinfo.at(i + 1).locationID)
                            {
                                ChgRhtIDChgTrgNum = i + 1;
                                break;
                            }
                        }
                        // update Lane id
                        for (int i = ChgRhtIDChgTrgNum; i < nodehvinfo.size(); i++)
                        {
                            nodehvinfo.at(i).locationID = rightobjlaneid;
                        }
                    }
                }
            }
        }
    }

#ifdef GLOG
    // analysis data
    DLOG(INFO) << "node size: " << nodehvinfo.size() << std::endl;
    for (int i = 0; i < nodehvinfo.size(); i++)
    {
        // DLOG(INFO) << "s: " << nodehvinfo[i].RELAT_S << std::endl;
        DLOG(INFO) << "s: " << nodehvinfo.at(i).RELAT_S << "\tnode id: " << int(nodehvinfo.at(i).locationID) << std::endl;
    }
    DLOG(INFO) << "carpos egolane id: " << int(_cur_EgoLaneId) << std::endl;
#endif
}

uint8_t NodeUpdate::CorIDMatchLaneID(const PD::PD_Input &pd_input)
{
    uint32_t Target_Corid = 0;
    uint8_t Target_Laneid = 0;

    Target_Corid = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).corridor_id;

    // traverse corridor list to find Target_Corid
    for (int i = 0; i < pd_input.rm_roadmodel.at(rm_Num).lane_list.size(); i++)
    {
        for (int j = 0; j < pd_input.rm_roadmodel.at(rm_Num).lane_list.at(i).corridor_list.size(); j++)
        {
            if (Target_Corid == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(i).corridor_list[j].corridor_id)
            {
                Target_Laneid = pd_input.rm_roadmodel.at(rm_Num).lane_list.at(i).start_id;
            }
        }
    }
    DLOG(INFO) << "Target_Laneid: " << int(Target_Laneid)
               << "\t cor id: " << int(pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).corridor_id)
               << "\taction: " << int(pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type);

    return Target_Laneid;
}

bool ADC::PD_NodeUpdate::Init(const PD_EgoVehTrj::EgoVehTrj &egovehtrj,
                              const PD_SVEstmd::SVEstmd &svtrajpnt)
{
    // check trajectory point
    bool _nodeinitFlag = true;
    _nodeinitFlag = _nodeinitFlag && !(egovehtrj.egoveh_tp.empty());
    _nodeinitFlag = _nodeinitFlag && !(svtrajpnt.SV_Trajectory_list.empty());

    // DLOG(INFO) << "egoveh_tp size: " << egovehtrj.egoveh_tp.size() << std::endl;
    // DLOG(INFO) << "svtrajpnt.SV_Trajectory_list size: " << svtrajpnt.SV_Trajectory_list.size() << std::endl;

    return _nodeinitFlag;
}

void NodeUpdate::LessLaneWidLeadClsn(const PD::PD_Input &pd_input)
{

    DstntionLaneMkID dstntionlanemk_id;

    // find destination lane left lane_marker id and right marker id
    for (int m = 0; m < pd_input.rm_roadmodel.at(rm_Num).lane_list.size(); m++)
    {
        if (nodehvinfo.back().locationID == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(m).start_id)
        {

            for (int i = 0; i < pd_input.rm_roadmodel.at(rm_Num).lane_list.at(m).left_lane_marker_id_list.size(); i++)
            {
                for (int mk_indx = 0; mk_indx < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.size(); mk_indx++)
                {
                    // get destination left/right lane_maker id
                    // if (pd_input.rm_roadmodel.at(rm_Num).lane_list.at(m).left_lane_marker_id_list[i] == pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(mk_indx).id)
                    if (pd_input.rm_roadmodel.at(rm_Num).lane_list.at(m).left_lane_marker_id_list.at(i) == pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(mk_indx).id)
                    {
                        // dstntionlanemk_id.LftMk_id = pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[mk_indx].id;
                        dstntionlanemk_id.LftMk_id = pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(mk_indx).id;
                        break;
                    }
                }
            }
        }
    }

    for (int m = 0; m < pd_input.rm_roadmodel.at(rm_Num).lane_list.size(); m++)
    {
        if (nodehvinfo.back().locationID == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(m).start_id)
        {

            for (int i = 0; i < pd_input.rm_roadmodel.at(rm_Num).lane_list.at(m).right_lane_marker_id_list.size(); i++)
            {
                for (int mk_indx = 0; mk_indx < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.size(); mk_indx++)
                {
                    // get destination left/right lane_maker id
                    // if (pd_input.rm_roadmodel.at(rm_Num).lane_list.at(m).right_lane_marker_id_list[i] == pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(mk_indx).id)
                    if (pd_input.rm_roadmodel.at(rm_Num).lane_list.at(m).right_lane_marker_id_list.at(i) == pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(mk_indx).id)
                    {
                        // dstntionlanemk_id.RgtMk_id = pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[mk_indx].id;
                        dstntionlanemk_id.RgtMk_id = pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(mk_indx).id;
                        break;
                    }
                }
            }
        }
    }

    // 20220414 update insufficient lane widht lead to collision

    // according to destination lane marker id to find related Y value;

    float Lanebry_ArcLength = 0.0f; // sum of each of lane boundary lenght
    int FrntLaneBryIndx = 0;        // when lenght of lane boundary is bigger than lgttrajectory distan and get related front land boundary indx.
    int Lft_FrntLaneBryIndx = 0;    // when length of lane boundary is bigger than lgttrajectory distance and get related left front land boundary indx.
    int Rgt_FrntLaneBryIndx = 0;    // when length of lane boundary is bigger than lgttrajectory distance and get related left right land boundary indx.

    float Lft_Lanebry_ArcLen = 0.0f;
    float Rgt_Lanebry_ArcLen = 0.0f;

    int LftLanemkIndx = 0;
    int RgtLanemkIndx = 0;
    float LanebryHoldVal = 0.5f; // prevent lane boundary arclength is 0;

    for (int j = 0; j < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.size(); j++)
    {
        if (dstntionlanemk_id.LftMk_id == pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[j].id)
        {
            LftLanemkIndx = j;
            for (int LBsz = 0; LBsz < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(j).front_lane_boundary_list.size(); LBsz++)
            {
                // if (nodehvinfo.back().RELAT_S > Lanebry_ArcLength)
                if (nodehvinfo.back().RELAT_S > Lft_Lanebry_ArcLen)
                {
                    // Lanebry_ArcLength = Lanebry_ArcLength + pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[j].front_lane_boundary_list.at(LBsz).arc_length;
                    // Lanebry_ArcLength = Lanebry_ArcLength + pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(j).front_lane_boundary_list.at(LBsz).arc_length;
                    // FrntLaneBryIndx = LBsz; //*****************************************************//

                    Lft_Lanebry_ArcLen = Lft_Lanebry_ArcLen + pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(j).front_lane_boundary_list.at(LBsz).arc_length;
                    Lft_FrntLaneBryIndx = LBsz;
                    if (pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[j].front_lane_boundary_list.at(LBsz).arc_length < LanebryHoldVal)
                    {

                        break;
                    }
                }
                else
                {
                    break;
                }
            }
            // // analysis front lane boundary arc length
            // for (auto flb : pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[j].front_lane_boundary_list)
            // {
            //     DLOG(INFO) << "Lftlanemarker_flbLen: " << flb.arc_length << std::endl;
            // }

            // DLOG(INFO) << "flb_size: " << int(pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[j].front_lane_boundary_list.size()) << std::endl;

            // DLOG(INFO) << "Lft_FrntLaneBryIndx: " << int(Lft_FrntLaneBryIndx) << std::endl;
            // DLOG(INFO) << "LftLanemkIndx: " << LftLanemkIndx << std::endl;

            // DLOG(INFO) << "****************************************" << std::endl;
        }

        if (dstntionlanemk_id.RgtMk_id == pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[j].id)
        {
            RgtLanemkIndx = j;
            for (int LBsz = 0; LBsz < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(j).front_lane_boundary_list.size(); LBsz++)
            {
                if (nodehvinfo.back().RELAT_S > Rgt_Lanebry_ArcLen)
                {
                    // Lanebry_ArcLength = Lanebry_ArcLength + pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[j].front_lane_boundary_list.at(LBsz).arc_length;
                    Rgt_Lanebry_ArcLen = Rgt_Lanebry_ArcLen + pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(j).front_lane_boundary_list.at(LBsz).arc_length;
                    Rgt_FrntLaneBryIndx = LBsz;
                    if (pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[j].front_lane_boundary_list.at(LBsz).arc_length < LanebryHoldVal)
                    {

                        break;
                    }
                }
                else
                {
                    break;
                }
            }

// analysis front lane boundary data
#ifdef GLGO
            for (auto flb : pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[j].front_lane_boundary_list)
            {
                DLOG(INFO) << "Rgtlanemarker_flbLen: " << flb.arc_length << std::endl;
            }
#endif
        }
    }

    // to get minimum FrntLaneBryIndx

    // DLOG(INFO) << "Rgt_FrntLaneBryIndx: " << Rgt_FrntLaneBryIndx << std::endl;
    // DLOG(INFO) << "Lft_FrntLaneBryIndx: " << Lft_FrntLaneBryIndx << std::endl;
    // DLOG(INFO) << "Rgt_LanebryLend: " << Rgt_Lanebry_ArcLen << std::endl;
    // DLOG(INFO) << "Lft_LanebryLend: " << Lft_Lanebry_ArcLen << std::endl;
    if (Lft_FrntLaneBryIndx >= Rgt_FrntLaneBryIndx)
    {
        FrntLaneBryIndx = Rgt_FrntLaneBryIndx;
        Lanebry_ArcLength = Rgt_Lanebry_ArcLen;
    }
    else
    {
        FrntLaneBryIndx = Lft_FrntLaneBryIndx;
        Lanebry_ArcLength = Lft_Lanebry_ArcLen;
    }

    // get left/right lane boundary Y value
    // ********************//

    float LftSpmPnt_Y = 0.0f;
    float RgtSpmPnt_Y = 0.0f;
    float Lanebry_ArcLengthThrsVal = 1.0f;
    bool LftLnebryLneNotEnough = false;
    bool RgtLnebryLneNotEnough = false;
    bool RateSpecialTrg = false;

    if (FrntLaneBryIndx >= static_cast<int>(1) && (Lanebry_ArcLength > Lanebry_ArcLengthThrsVal)) // lane change lgt distance over first vecotr in front_lane_boundary_list
    {
        // 2 cases:
        // 1. general case,lftlanebry size equal to rgtlanebry size
        // 2. special case,lftlanebry size is not equal to rgtlanebry size

        // get related indx rate
        float FrntVecLanebry_ArcLength = 0.0f;

        if (Lft_FrntLaneBryIndx == Rgt_FrntLaneBryIndx) // general case
        {
            for (int m = 0; m <= FrntLaneBryIndx - 1; m++)
            {
                FrntVecLanebry_ArcLength = FrntVecLanebry_ArcLength + pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[LftLanemkIndx].front_lane_boundary_list.at(m).arc_length;
#ifdef GLOG
                DLOG(INFO) << "tem_m: " << m << std::endl;
                DLOG(INFO) << " FrntVecLanebry_ArcLength: " << FrntVecLanebry_ArcLength << std::endl;
#endif
            }
        }
        else
        {
            FrntVecLanebry_ArcLength = std::min(Rgt_Lanebry_ArcLen, Lft_Lanebry_ArcLen);
            FrntLaneBryIndx = std::min(Rgt_FrntLaneBryIndx, Lft_FrntLaneBryIndx);
            RateSpecialTrg = true;
        }

        float LftRelatLneRate = 0.0f;
        float RgtRelatLneRate = 0.0f;
        int LftRelatSmpPnt_Y_Indx = 0;
        int RgtRelatSmpPnt_Y_Indx = 0;
        float Dvid_0_ProtcdVal = 0.01f;
        float Rate_ProtcdVal = 0.99f; // prevent lanebry arc length is 0;
        float LaneWidthThrs = 2.5f;   // lane width threshold value

        // special rate case
        // if (RateSpecialTrg == true && (nodehvinfo.back().RELAT_S >= FrntVecLanebry_ArcLength))
        if (RateSpecialTrg == true)
        {
            LftRelatLneRate = Rate_ProtcdVal;
            RgtRelatLneRate = Rate_ProtcdVal;
        }
        else
        {

            // LftRelatLneRate = (nodehvinfo.back().RELAT_S - FrntVecLanebry_ArcLength) / (pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[LftLanemkIndx].front_lane_boundary_list[FrntLaneBryIndx].arc_length + Dvid_0_ProtcdVal);
            LftRelatLneRate = (nodehvinfo.back().RELAT_S - FrntVecLanebry_ArcLength) / (pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(LftLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).arc_length + Dvid_0_ProtcdVal);

            if (LftRelatLneRate >= Rate_ProtcdVal)
            {
                LftLnebryLneNotEnough = true;
                LftRelatLneRate = Rate_ProtcdVal;
            }

            RgtRelatLneRate = (nodehvinfo.back().RELAT_S - FrntVecLanebry_ArcLength) / (pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(RgtLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).arc_length + Dvid_0_ProtcdVal);

            if (RgtRelatLneRate > Rate_ProtcdVal)
            {
                RgtLnebryLneNotEnough = true;
                RgtRelatLneRate = Rate_ProtcdVal;
            }
        }
        // nodehvinfo.back().RELAT_S
        // DLOG(INFO) << "^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^" << std::endl;
        // DLOG(INFO) << "lgt_s: " << nodehvinfo.back().RELAT_S << "\tLanebry_ArcLength: " << Lanebry_ArcLength << std::endl;

        // DLOG(INFO) << "relatedSampSize: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(LftLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).sampling_point_list.size() << std::endl;
        // DLOG(INFO) << std::endl;
        DLOG(INFO) << "ego lane id: " << int(pd_input.rm_roadmodel.at(rm_Num).car_position.ego_lane_id) << "\tbehavior: " << int(pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type) << std::endl;
        if ((LftLnebryLneNotEnough == false))
        {
            // DLOG(INFO) << "at_Rgt_SampntSize: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(RgtLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).sampling_point_list.size() << std::endl;

            if (!(pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(LftLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).sampling_point_list.empty()))
            {
                LftRelatSmpPnt_Y_Indx = static_cast<int>(LftRelatLneRate * pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(LftLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).sampling_point_list.size());

                DLOG(INFO) << "LftLaneMkIndx: " << LftLanemkIndx << "\tLftLaneMkIndx_ID: " << int(pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(LftLanemkIndx).id) << std::endl;

                if (pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(LftLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).sampling_point_list.size() >= (LftRelatSmpPnt_Y_Indx + 1) && (LftRelatSmpPnt_Y_Indx >= 0))
                {
                    LftSpmPnt_Y = pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(LftLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).sampling_point_list[LftRelatSmpPnt_Y_Indx].y; // get left lane boundary Y value
                    DLOG(INFO) << "LftSpmPnt_YY: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(LftLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).sampling_point_list.at(LftRelatSmpPnt_Y_Indx).y << std::endl;
                }
            }

            if (!(pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(RgtLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).sampling_point_list.empty()))
            {
                RgtRelatSmpPnt_Y_Indx = static_cast<int>(RgtRelatLneRate * pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(RgtLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).sampling_point_list.size());
                // DLOG(INFO) << std::endl;
                // DLOG(INFO) << "RgtLaneMkIndx: " << RgtLanemkIndx << "\tRgtLaneMkIndx_ID: " << int(pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(RgtLanemkIndx).id) << std::endl;
                // DLOG(INFO) << "FrntLaneBryIndx: " << FrntLaneBryIndx << std::endl;

                // DLOG(INFO) << "Rgt_SampntSize: " << +pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(RgtLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).sampling_point_list.size() << std::endl;
                // DLOG(INFO) << std::endl;
                if (pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(RgtLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).sampling_point_list.size() >= (RgtRelatSmpPnt_Y_Indx + 1) && (RgtRelatSmpPnt_Y_Indx >= 0))
                {
                    RgtSpmPnt_Y = pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(RgtLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).sampling_point_list.at(RgtRelatSmpPnt_Y_Indx).y; // get right lane boundary Y value
                    DLOG(INFO) << "RgtSpmPnt_YY: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(RgtLanemkIndx).front_lane_boundary_list.at(FrntLaneBryIndx).sampling_point_list.at(RgtRelatSmpPnt_Y_Indx).y << std::endl;
                }
            }

            if ((LftSpmPnt_Y - RgtSpmPnt_Y) < LaneWidthThrs)
            {
                InsfcntLaneWidClsnFlag = true;
            }
            DLOG(INFO) << "Diff_val: " << (LftSpmPnt_Y - RgtSpmPnt_Y) << std::endl;
        }
#ifdef GLOG
        DLOG(INFO) << std::endl;
        DLOG(INFO) << "RgtRelatLneRate: " << RgtRelatLneRate << "\tLftRelatLneRate: " << LftRelatLneRate << std::endl;
        DLOG(INFO) << "LftSpmPnt_Y: " << LftSpmPnt_Y << "\tRgtSpmPnt_Y: " << RgtSpmPnt_Y << std::endl;

        DLOG(INFO) << "Diff_len: " << Lanebry_ArcLength - FrntVecLanebry_ArcLength << std::endl;
        DLOG(INFO) << "Lft_Y_Indx: " << LftRelatSmpPnt_Y_Indx << "\tRgt_Y_Indx: " << RgtRelatSmpPnt_Y_Indx << std::endl;
#endif
    }

    // DLOG(INFO) << "^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^" << std::endl;

} // lane width lead to collision

bool NodeUpdate::RoadEndProc(const PD::PD_Input &pd_input)
{

    bool RoadEndSts = false;
    uint8_t EgoID = pd_input.rm_roadmodel.at(rm_Num).car_position.ego_lane_id;
    uint8_t TargetLaneID = CorIDMatchLaneID(pd_input);
    float TargetLane_endRge = 0.0f;
    float TargetNeighborLane_endRge = 0.0f;
    float LaneRgeEqulNeigLaneThrsVal = 0.2f;

    if (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == static_cast<uint8_t>(2)) // left secenario
    {
        // traverse lane list
        for (int ii = 0; ii < pd_input.rm_roadmodel.at(rm_Num).lane_list.size(); ii++)
        {
            if (EgoID == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).start_id)
            {
                // travrse neighbor lane
                for (int jj = 0; jj < pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).left_neighbor_lane.size(); jj++)
                {
                    if (TargetLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).left_neighbor_lane.at(jj).lane_id) // in left neighbor lane
                    {
                        TargetNeighborLane_endRge = pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).left_neighbor_lane.at(jj).end_range;
                        break;
                    }
                }
            }

            if (TargetLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).start_id)
            {
                TargetLane_endRge = pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).end_range;
                RoadEnd_outofRge = pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).is_end_out_of_range;
                break;
            }
        }

        DLOG(INFO) << "TargetNeighborLane_endRge: " << TargetNeighborLane_endRge
                   << "\tTargetLane_endRge: " << TargetLane_endRge << std::endl;
        if (fabs(TargetLane_endRge - TargetNeighborLane_endRge) < LaneRgeEqulNeigLaneThrsVal) // target neighbor lane length equal to target lane length in lane list,then roadendclsn sts is up to to is_end_out_of_range
        {
            if (TargetNeighborLane_endRge <= PD_RdEndClsnTimeVal * pd_input.VSE_LgtVehSpd) // relate with time distance to Destination lane

            {
                RoadEndSts = true;
            }
        }
#ifdef GLOG
        DLOG(INFO) << "Left Lane Change info" << std::endl;
        DLOG(INFO) << "TgtLane E_rg: " << TargetNeighborLane_endRge << "\tRoadEndSts: " << RoadEndSts;
        DLOG(INFO) << "outofRge: " << RoadEnd_outofRge
                   << "\tcomp_Range: " << PD_RdEndClsnTimeVal * pd_input.VSE_LgtVehSpd
                   << "\tduration time: " << pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).duration_time
                   << "\tdur tm range: " << pd_input.VSE_LgtVehSpd * pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).duration_time;
#endif
    }
    else if (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == static_cast<uint8_t>(3)) // right secenario
    {
        // traverse lane list
        for (int ii = 0; ii < pd_input.rm_roadmodel.at(rm_Num).lane_list.size(); ii++)
        {
            if (EgoID == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).start_id)
            {
                // travrse neighbor lane
                for (int jj = 0; jj < pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).right_neighbor_lane.size(); jj++)
                {
                    if (TargetLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).right_neighbor_lane.at(jj).lane_id) // in left neighbor lane
                    {
                        TargetNeighborLane_endRge = pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).right_neighbor_lane.at(jj).end_range;
                        break;
                    }
                }
            }

            if (TargetLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).start_id)
            {
                TargetLane_endRge = pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).end_range;
                RoadEnd_outofRge = pd_input.rm_roadmodel.at(rm_Num).lane_list.at(ii).is_end_out_of_range;
                break;
            }
        }
#ifdef GLOG
        DLOG(INFO) << "Right Lane Change info" << std::endl;
        DLOG(INFO) << "TargetNeighborLane_endRge: " << TargetNeighborLane_endRge
                   << "\tTargetLane_endRge: " << TargetLane_endRge << std::endl;
#endif

        if (fabs(TargetLane_endRge - TargetNeighborLane_endRge) < LaneRgeEqulNeigLaneThrsVal)
        {

            if (TargetNeighborLane_endRge <= PD_RdEndClsnTimeVal * pd_input.VSE_LgtVehSpd) // relate with time distance to Destination lane

            {
                RoadEndSts = true;
            }
        }
#ifdef GLOG
        DLOG(INFO) << "R_TgtLane E_rg: " << TargetNeighborLane_endRge << "\tRoadEndSts: " << RoadEndSts;
        DLOG(INFO) << "outofRge: " << RoadEnd_outofRge
                   << "\tcomp_Range: " << PD_RdEndClsnTimeVal * pd_input.VSE_LgtVehSpd
                   << "\tduration time: " << pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).duration_time
                   << "\tdur tm range: " << pd_input.VSE_LgtVehSpd * pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).duration_time;
#endif
    }

    return RoadEndSts;
}

void NodeUpdate::RoadEndLeadClsnProc(const PD::PD_Input &pd_input)
{
    // to get min len between ego lane and destination lane in lane list
    float NeghbRdEndClsnDist = 0.0f; // collision due road end colibration parameter
    float RdEndClsn_TimeVal = 1.0f;

    uint8_t LaneChgDstinLaneID = 0;
    uint8_t EgoVehLaneID = 0;
    float CrsLineRange = 0.0f;
    float EgoLaneLen = 0.0f;
    float TgtLaneLen = 0.0f;
    float ChgLane_LaneMinLen = 0.0f;

    LaneChgDstinLaneID = CorIDMatchLaneID(pd_input);
    EgoVehLaneID = pd_input.rm_roadmodel.at(rm_Num).car_position.ego_lane_id;
    CrsLineRange = CrsLineTrjPntProc();

#ifdef GLOG
    DLOG(INFO) << "ego id: " << int(EgoVehLaneID)
               << "\tTgt id: " << int(LaneChgDstinLaneID)
               << "\tCrsLineRge: " << CrsLineRange;
#endif

    // get ego lane len from lane list
    for (int i = 0; i < pd_input.rm_roadmodel.at(rm_Num).lane_list.size(); i++)
    {
        if (EgoVehLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list[i].end_id)
        {
            EgoLaneLen = pd_input.rm_roadmodel.at(rm_Num).lane_list[i].end_range;
        }
        // get destination lane len from lane list
        if (LaneChgDstinLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list[i].end_id)
        {
            TgtLaneLen = pd_input.rm_roadmodel.at(rm_Num).lane_list[i].end_range;
        }
    }
#ifdef GLOG
    DLOG(INFO) << "EgoLaneLen: " << EgoLaneLen
               << "\tTgeLaneLen: " << TgtLaneLen
               << "\ttm clsnval: " << pd_input.VSE_LgtVehSpd * RdEndClsn_TimeVal;
#endif
    ChgLane_LaneMinLen = std::min(EgoLaneLen, TgtLaneLen);

    if (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == static_cast<uint8_t>(2) ||
        (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == static_cast<uint8_t>(3)))

    {
        if (ChgLane_LaneMinLen - CrsLineRange <= pd_input.VSE_LgtVehSpd * RdEndClsn_TimeVal)
        {
            RdEndClsnFlag = true;
        }
    }
}

void NodeUpdate::RoadEndLeadClsn(const PD::PD_Input &pd_input) // avoid across lane to lane change
{
    // case 5: Collision due to road end (destination Lane length  is not satisfied)

    float NeghbRdEndClsnDist = 0.0f; // collision due road end colibration parameter
    float RdEndClsn_TimeVal = 1.0f;

    uint8_t LaneChgDstinLaneID = 0;
    uint8_t EgoVehLaneID = 0;
    float CrsLineRange = 0.0f;
    // get destination lane id
    // LaneChgDstinLaneID = pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).corridor_id;

    LaneChgDstinLaneID = CorIDMatchLaneID(pd_input);
    EgoVehLaneID = pd_input.rm_roadmodel.at(rm_Num).car_position.ego_lane_id;
    CrsLineRange = CrsLineTrjPntProc();

    DLOG(INFO) << "LaneChgDstinLaneID: " << int(LaneChgDstinLaneID)
               << "\tEgoVehLaneID: " << int(EgoVehLaneID)
               << "\tCrsLineRange: " << CrsLineRange;
    DLOG(INFO) << std::endl;

    // change left
    if (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == static_cast<uint8_t>(2))
    {

        for (int i = 0; i < pd_input.rm_roadmodel.at(rm_Num).lane_list.size(); i++)
        {
            // 20220802: accroding to CrlLineRange to judge RdEndClsnFlag
            if (RoadEndProc(pd_input)) // is end out of range 1:no end
            {
                RdEndClsnFlag = !RoadEnd_outofRge;
                DLOG(INFO) << "LftRoadEnd_outofRge: " << RoadEnd_outofRge << "\tLftRdEndClsnFlag: " << RdEndClsnFlag << std::endl;
                DLOG(INFO) << "spd: " << pd_input.VSE_LgtVehSpd;
                DLOG(INFO) << std::endl;
            }

            // else if (EgoVehLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list[i].start_id)
            else

            {
                // for (int j = 0; j < pd_input.rm_roadmodel.at(rm_Num).lane_list[i].left_neighbor_lane.size(); j++)
                // {
                //     if (LaneChgDstinLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list[i].left_neighbor_lane[j].lane_id)
                //     {
                //         # ifdef GLOG
                //         // DLOG(INFO) << "lgt_s: " << nodehvinfo.back().RELAT_S << "\tCrsLineRange: " << CrsLineRange << std::endl;

                //         // DLOG(INFO) << "egoLane Len: " << pd_input.rm_roadmodel.at(rm_Num).lane_list[i].end_range
                //         //            << "\tobj lftlane s_len : " << pd_input.rm_roadmodel.at(rm_Num).lane_list[i].left_neighbor_lane[j].start_range
                //         //            << "\tobj lftlane e_len : " << pd_input.rm_roadmodel.at(rm_Num).lane_list[i].left_neighbor_lane[j].end_range << std::endl;

                //         // DLOG(INFO) << "ego lane id: " << int(EgoVehLaneID) << "\tobj lftlane id : "
                //         //            << int(pd_input.rm_roadmodel.at(rm_Num).lane_list[i].left_neighbor_lane[j].lane_id)
                //         //            << "\tLftRoadEnd_outofRge: " << RoadEnd_outofRge << std::endl;
                //         # endif

                //         // when ego lane end range is not enough, accroding to left neighbot lane id to find lane end range is enough or not?
                //         if (pd_input.rm_roadmodel.at(rm_Num).lane_list[i].end_range - CrsLineRange < NeghbRdEndClsnDist) // ego lane end range is not enough
                //         {
                //             // tranverse lane list to find neighbor lane id

                //             if (LaneChgDstinLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(i).start_id) // from lane list to find neighbor lane id
                //             {
                //                 // DLOG(INFO) << "lane list_L_targtlane len: " << pd_input.rm_roadmodel.at(rm_Num).lane_list[i].end_range << std::endl;
                //                 if (pd_input.rm_roadmodel.at(rm_Num).lane_list.at(i).end_range - CrsLineRange < NeghbRdEndClsnDist)
                //                 {
                //                     RdEndClsnFlag = true;
                //                     break;
                //                 }
                //             }
                //         }
                //         else if (pd_input.rm_roadmodel.at(rm_Num).lane_list[i].left_neighbor_lane[j].end_range - CrsLineRange < NeghbRdEndClsnDist) // ego lane end range is enough,judge neighbor lane end range;
                //         {
                //             RdEndClsnFlag = true;
                //             break;
                //         }
                //     }
                // }
                // break;
                if (LaneChgDstinLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(i).start_id)
                {
                    if (pd_input.rm_roadmodel.at(rm_Num).lane_list[i].end_range - CrsLineRange < pd_input.VSE_LgtVehSpd * RdEndClsn_TimeVal)
                    {
                        RdEndClsnFlag = true;
                        break;
                    }
                }
            }
        }
    }

    // change right
    if (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == static_cast<uint8_t>(3))
    {

        for (int i = 0; i < pd_input.rm_roadmodel.at(rm_Num).lane_list.size(); i++)
        {
            if (RoadEndProc(pd_input)) // case 1: neighbor lane len is not equal to lane list len,to judge neighbor lane len is enough or not?
            {
                RdEndClsnFlag = !RoadEnd_outofRge;
                DLOG(INFO) << "RgtRoadEnd_outofRge: " << RoadEnd_outofRge << "\tRgtRdEndClsnFlag: " << RdEndClsnFlag << std::endl;
                DLOG(INFO) << std::endl;
                break;
            }

            // else if (EgoVehLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list[i].start_id)
            else // case 2: lane change scenario lane len is up to lane list
            {
                // for (int j = 0; j < pd_input.rm_roadmodel.at(rm_Num).lane_list[i].right_neighbor_lane.size(); j++)
                // {
                //     if (LaneChgDstinLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list[i].right_neighbor_lane[j].lane_id)
                //     {
                //         DLOG(INFO) << "lgt_s: " << nodehvinfo.back().RELAT_S << "\tCrsLineRange: " << CrsLineRange << std::endl;

                //         DLOG(INFO) << "egoLane Len: " << pd_input.rm_roadmodel.at(rm_Num).lane_list[i].end_range
                //                    << "\tobj rgtlane s_len : " << pd_input.rm_roadmodel.at(rm_Num).lane_list[i].right_neighbor_lane[j].start_range
                //                    << "\tobj rgtlane e_len : " << pd_input.rm_roadmodel.at(rm_Num).lane_list[i].right_neighbor_lane[j].end_range << std::endl;

                //         DLOG(INFO) << "ego lane id: " << int(EgoVehLaneID) << "\tobj rgtlane id : "
                //                    << int(pd_input.rm_roadmodel.at(rm_Num).lane_list[i].right_neighbor_lane[j].lane_id)
                //                    << "\tRgtRoadEnd_outofRge: " << RoadEnd_outofRge
                //                    << "tgt cor_id: " << int(pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).corridor_id);

                //         // when ego lane end range is not enough, accroding to left neighbot lane id to find lane end range is enough or not?
                //         if (pd_input.rm_roadmodel.at(rm_Num).lane_list[i].end_range - CrsLineRange < NeghbRdEndClsnDist) // ego lane end range is not enough?
                //         {
                //             // tranverse lane list to find neighbor lane id

                //             if (LaneChgDstinLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(i).start_id)
                //             {
                //                 // DLOG(INFO) << "lane list_R_targtlane len: " << pd_input.rm_roadmodel.at(rm_Num).lane_list[i].end_range << std::endl;
                //                 if (pd_input.rm_roadmodel.at(rm_Num).lane_list.at(i).end_range - CrsLineRange < NeghbRdEndClsnDist)
                //                 {
                //                     RdEndClsnFlag = true;
                //                     break;
                //                 }
                //             }
                //         }
                //         else if (pd_input.rm_roadmodel.at(rm_Num).lane_list[i].right_neighbor_lane[j].end_range - CrsLineRange < NeghbRdEndClsnDist) // ego lane len enough
                //         {
                //             // DLOG(INFO) << " len enough " << std::endl;
                //             RdEndClsnFlag = true;
                //             break;
                //         }
                //     }
                //     DLOG(INFO) << std::endl;
                // }
                // break;

                if (LaneChgDstinLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list[i].end_id)
                {
                    if (pd_input.rm_roadmodel.at(rm_Num).lane_list[i].end_range - CrsLineRange < pd_input.VSE_LgtVehSpd * RdEndClsn_TimeVal)
                    {
                        RdEndClsnFlag = true;
                        break;
                    }
                }
            }
        }
    }
}

float NodeUpdate::CrsLineTrjPntProc()
{
    uint8_t TargetLaneid = nodehvinfo.back().locationID;
    int LaneIDIndx = 3;
    float CrsLineTrjPntRange = 0.0f;
    float temp_CrsLineTrjPntRange = 0.0f;
    int CrsLineTrjPntIndx = 0;
    if (nodehvinfo.size() >= LaneIDIndx)
    {
        if (TargetLaneid != nodehvinfo[nodehvinfo.size() - LaneIDIndx].locationID)
        {
            CrsLineTrjPntRange = nodehvinfo[nodehvinfo.size() - LaneIDIndx].RELAT_S;
        }
        else
        {
            for (int i = 0; i < nodehvinfo.size(); i++)
            {
                // DLOG(INFO) << "s: " << nodehvinfo[i].RELAT_S << "\tnode id: " << int(nodehvinfo[i].locationID) << std::endl;

                if (nodehvinfo[i].locationID != nodehvinfo[i + 1].locationID)
                {
                    CrsLineTrjPntIndx = i + 1;
                    break;
                }
            }
            if (CrsLineTrjPntIndx >= 1)
            {
                CrsLineTrjPntRange = nodehvinfo[CrsLineTrjPntIndx].RELAT_S;
                temp_CrsLineTrjPntRange = nodehvinfo[CrsLineTrjPntIndx - 1].RELAT_S;
                CrsLineTrjPntRange = 0.5 * (CrsLineTrjPntRange + temp_CrsLineTrjPntRange);
                // DLOG(INFO) << "CrsLineTrjPntIndx: " << int(CrsLineTrjPntIndx) << std::endl;
                DLOG(INFO) << "Avr_CrsLineTrjPntRange: " << CrsLineTrjPntRange << std::endl;
            }
            else
            {
                CrsLineTrjPntRange = 0;
            }
        }

        if (CrsLineTrjPntRange > nodehvinfo.back().RELAT_S)
        {
            CrsLineTrjPntRange = nodehvinfo.back().RELAT_S;
            DLOG(INFO) << "CrsLineTrjRange overflow!";
        }
    }

    return CrsLineTrjPntRange;
}

bool NodeUpdate::VehLaneChgStsProc(const PD::PD_Input &pd_input)
{
    // uint
    bool VehLCFlag = false;

    for (auto ele : pd_input.rm_roadmodel.at(rm_Num).passage_list)
    {
        if (ele.action_type == BA::BA_ActionTyp::BA_ActionTyp_LeftLaneChangeAbolition || (ele.action_type == BA::BA_ActionTyp::BA_ActionTyp_RightLaneChangeAbolition) 
        || (ele.action_type == BA::BA_ActionTyp::BA_ActionTyp_LeftLaneChange && (pd_input.rm_roadmodel.at(rm_Num).passage_list.size() == 1)) 
        || (ele.action_type == BA::BA_ActionTyp::BA_ActionTyp_RightLaneChange) && (pd_input.rm_roadmodel.at(rm_Num).passage_list.size() == 1))
        {
            VehLCFlag = true;
        }
        else
            VehLCFlag = false;
    }

    return VehLCFlag;
}

void NodeUpdate::StnEnvLeadClsn(const PD::PD_Input &pd_input)
{
    // case 2: Collision due to line type
    /*
    0 = unknown;
    1 = solid;
    2 = dashed;
    3 = double solid dashed;
    4 = double dashed solid;
    5 = double solid solid;
    6 = double dashed dashed;
    7 = botts;
    8 = deceleration;
    Others = reversed;
    */
    if (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == 2 ||
        pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == 3)
    {

        // egolane id
        uint8_t CrsLine_cur_EgoLaneId = 0;
        // float LaneEndRgeThrsVal = 500.0f;

        // int SelReltLineClrItm = 0;  // store change left line color attribute list indx;

        CrsLine_cur_EgoLaneId = pd_input.rm_roadmodel.at(rm_Num).car_position.ego_lane_id;

        for (int lane_indx = 0; lane_indx < pd_input.rm_roadmodel.at(rm_Num).lane_list.size(); lane_indx++) // get lane number
        {
            uint8_t ChgToTgtLaneID = 0;
            ChgToTgtLaneID = CorIDMatchLaneID(pd_input);

            if (CrsLine_cur_EgoLaneId == pd_input.rm_roadmodel.at(rm_Num).lane_list.at(lane_indx).start_id &&
                (CrsLine_cur_EgoLaneId != ChgToTgtLaneID))

            {
                // case 2.1: Collision due to cross left solide line
                if (pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type == 2)
                {
                    for (int lftlan_mkID_idx = 0; lftlan_mkID_idx < pd_input.rm_roadmodel.at(rm_Num).lane_list.at(lane_indx).left_lane_marker_id_list.size(); lftlan_mkID_idx++)
                    {
                        for (int lnemksz = 0; lnemksz < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.size(); lnemksz++)
                        {
                            if (pd_input.rm_roadmodel.at(rm_Num).lane_list.at(lane_indx).left_lane_marker_id_list.at(lftlan_mkID_idx) == pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).id) // get related lane marker id
                            {
                                DLOG(INFO) << std::endl;
                                DLOG(INFO) << "ego c0: " << pd_input.rm_roadmodel.at(rm_Num).lane_list[lane_indx].corridor_list.front().reference_line.c0
                                           << "\tego lane cor size: " << pd_input.rm_roadmodel.at(rm_Num).lane_list[lane_indx].corridor_list.size()
                                           << "\tego id: " << int(CrsLine_cur_EgoLaneId);
                                DLOG(INFO) << "lane mark id: " << int(pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).id);
                                DLOG(INFO) << "nodehvifo size: " << nodehvinfo.size();
                                DLOG(INFO) << std::endl;
                                for (int typsz = 0; typsz < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list.size(); typsz++)
                                {
                                    //
                                    if (VehLaneChgStsProc(pd_input)) //  if vehicle lane change at current,vehicle CrsSldLine logic or not considering reference line c0
                                    {

                                        if (!pd_input.rm_roadmodel.at(rm_Num).lane_list[lane_indx].corridor_list.empty() &&
                                            fabs(pd_input.rm_roadmodel.at(rm_Num).lane_list[lane_indx].corridor_list.front().reference_line.c0) <= PD_VehBckLaneC0LmtVal) // when c0 less than 0.4 and dash line len is not enough, ego vehicle can be pushed back.
                                        {

                                            if (!(nodehvinfo.empty()) && (nodehvinfo.size() >= 4))
                                            {

                                                if (nodehvinfo.front().locationID != nodehvinfo.back().locationID)
                                                {

                                                    if (nodehvinfo.at(PD_LgtCrsLneIndx).RELAT_S < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].end_offset &&
                                                        nodehvinfo.at(PD_LgtCrsLneIndx).RELAT_S > pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].start_offset /*&&
                                                        pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].end_offset < LaneEndRgeThrsVal*/
                                                    )
                                                    {
#ifdef GLOG
                                                        DLOG(INFO) << "Left Solide Line";
                                                        DLOG(INFO) << "Current time Lane change"
                                                                   << "\trm_id:(" << int(pd_input.rm_roadmodel.at(rm_Num).road_id.x) << "," << int(pd_input.rm_roadmodel.at(rm_Num).road_id.y) << ")" << std::endl;
                                                        DLOG(INFO) << "lgt_s: " << nodehvinfo.back().RELAT_S
                                                                   << "\tnode_1s_RELAT_S: " << nodehvinfo.at(PD_LgtCrsLneIndx).RELAT_S
                                                                   << "\tlinetype: " << int(pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).line_type_attribute_list.at(typsz).linetype) << std::endl;
                                                        DLOG(INFO) << "\trm_Num: " << rm_Num
                                                                   << "lnemksiz: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.size()
                                                                   << "\ttypsz: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list.size()
                                                                   << "\tlnemksz_indx: " << lnemksz
                                                                   << "\ttypsz_indx: " << typsz << std::endl;
                                                        DLOG(INFO) << "end_offset: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).line_type_attribute_list.at(typsz).end_offset
                                                                   << "\tstart_offset: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).line_type_attribute_list.at(typsz).start_offset << std::endl;
                                                        DLOG(INFO) << std::endl;
#endif
                                                        if (pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].linetype == 1 ||
                                                            pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].linetype == 3 ||
                                                            pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].linetype == 5)
                                                        {
                                                            CrsSldLineClsnFlag = true;

                                                            break;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }

                                    else // at current time vehicle not lane change,CrsSldLineClsn is up to 1.5 headdistance.
                                    {
                                        if (!(nodehvinfo.empty()) && (nodehvinfo.size() >= 4))
                                        {

                                            if (nodehvinfo.front().locationID != nodehvinfo.back().locationID)
                                            {

                                                if (nodehvinfo.at(PD_LgtCrsLneIndx).RELAT_S < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].end_offset &&
                                                    nodehvinfo.at(PD_LgtCrsLneIndx).RELAT_S > pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].start_offset /*&&
                                                    pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].end_offset < LaneEndRgeThrsVal*/
                                                )
                                                {
#ifdef GLOG
                                                    DLOG(INFO) << "Left Solide Line";
                                                    DLOG(INFO) << "Current time no change"
                                                               << "\trm_id:(" << int(pd_input.rm_roadmodel.at(rm_Num).road_id.x) << "," << int(pd_input.rm_roadmodel.at(rm_Num).road_id.y) << ")" << std::endl;
                                                    DLOG(INFO) << "lgt_s: " << nodehvinfo.back().RELAT_S
                                                               << "\tnode_1s_RELAT_S: " << nodehvinfo.at(PD_LgtCrsLneIndx).RELAT_S
                                                               << "\tlinetype: " << int(pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).line_type_attribute_list.at(typsz).linetype) << std::endl;
                                                    DLOG(INFO) << "\trm_Num: " << rm_Num
                                                               << "lnemksiz: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.size()
                                                               << "\ttypsz: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list.size()
                                                               << "\tlnemksz_indx: " << lnemksz
                                                               << "\ttypsz_indx: " << typsz << std::endl;
                                                    DLOG(INFO) << "end_offset: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).line_type_attribute_list.at(typsz).end_offset
                                                               << "\tstart_offset: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).line_type_attribute_list.at(typsz).start_offset << std::endl;
                                                    DLOG(INFO) << std::endl;
#endif
                                                    if (pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].linetype == 1 ||
                                                        pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].linetype == 3 ||
                                                        pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].linetype == 5)
                                                    {
                                                        CrsSldLineClsnFlag = true;

                                                        break;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }

                                break;
                            }
                        }
                    }
                }
                else
                {
                    // case 2.2: Collision due to cross right solide line
                    /*
                    在换到过程中,自车所在的当前位置如果lane boundary为实线,当节点反馈为碰撞
                    */
                    for (int rgtlan_mkID_idx = 0; rgtlan_mkID_idx < pd_input.rm_roadmodel.at(rm_Num).lane_list.at(lane_indx).right_lane_marker_id_list.size(); rgtlan_mkID_idx++)
                    {
                        for (int lnemksz = 0; lnemksz < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.size(); lnemksz++)
                        {
                            if (pd_input.rm_roadmodel.at(rm_Num).lane_list.at(lane_indx).right_lane_marker_id_list.at(rgtlan_mkID_idx) == pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).id) // get related lane marker id
                            {

                                DLOG(INFO) << "Right Lane Change info" << std::endl;
                                DLOG(INFO) << "ego c0: " << pd_input.rm_roadmodel.at(rm_Num).lane_list[lane_indx].corridor_list.front().reference_line.c0
                                           << "\tego lane cor size: " << pd_input.rm_roadmodel.at(rm_Num).lane_list[lane_indx].corridor_list.size()
                                           << "\tego id: " << int(CrsLine_cur_EgoLaneId);
                                DLOG(INFO) << "lane mark id: " << int(pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).id);
                                DLOG(INFO) << "nodehvifo size: " << nodehvinfo.size();

                                DLOG(INFO) << "psg size: " << pd_input.rm_roadmodel.at(rm_Num).passage_list.size()
                                           << "\trd size: " << pd_input.rm_roadmodel.size();
                                DLOG(INFO) << std::endl;
                                for (int typsz = 0; typsz < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list.size(); typsz++)
                                {
                                    // if (nodehvinfo.back().RELAT_S < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].end_offset &&
                                    //     nodehvinfo.back().RELAT_S > pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].start_offset)
                                    if (VehLaneChgStsProc(pd_input))
                                    {

                                        if (!pd_input.rm_roadmodel.at(rm_Num).lane_list[lane_indx].corridor_list.empty() &&
                                            fabs(pd_input.rm_roadmodel.at(rm_Num).lane_list[lane_indx].corridor_list.front().reference_line.c0) <= PD_VehBckLaneC0LmtVal) // when c0 less than 0.4 and dash line len is not enough, ego vehicle can be pushed back.
                                        {
                                            if (!(nodehvinfo.empty()) && (nodehvinfo.size() >= 4))
                                            {
                                                if (nodehvinfo.front().locationID != nodehvinfo.back().locationID)
                                                {
                                                    if (nodehvinfo.at(PD_LgtCrsLneIndx).RELAT_S < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].end_offset &&
                                                        nodehvinfo.at(PD_LgtCrsLneIndx).RELAT_S > pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].start_offset /*&&
                                                        pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].end_offset < LaneEndRgeThrsVal*/
                                                    )
                                                    {
#ifdef GLOG
                                                        DLOG(INFO) << "Right Solide Line";
                                                        DLOG(INFO) << "Current time Lane change"
                                                                   << "\trm_id:(" << int(pd_input.rm_roadmodel.at(rm_Num).road_id.x) << "," << int(pd_input.rm_roadmodel.at(rm_Num).road_id.y) << ")" << std::endl;
                                                        DLOG(INFO) << "lgt_s: " << nodehvinfo.back().RELAT_S
                                                                   << "\ttnode_1s_RELAT_S: " << nodehvinfo.at(PD_LgtCrsLneIndx).RELAT_S
                                                                   << "\tlinetype: " << int(pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).line_type_attribute_list.at(typsz).linetype) << std::endl;

                                                        DLOG(INFO) << "\trm_Num: " << rm_Num
                                                                   << "lnemksiz: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.size()
                                                                   << "\ttypsz: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list.size()
                                                                   << "\tlnemksz_indx: " << lnemksz
                                                                   << "\ttypsz_indx: " << typsz << std::endl;

                                                        DLOG(INFO) << "end_offset: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).line_type_attribute_list.at(typsz).end_offset
                                                                   << "\tstart_offset: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).line_type_attribute_list.at(typsz).start_offset << std::endl;
                                                        DLOG(INFO) << std::endl;
#endif
                                                        if (pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].linetype == 1 ||
                                                            pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].linetype == 3 ||
                                                            pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].linetype == 5)
                                                        {
                                                            CrsSldLineClsnFlag = true;

                                                            break;
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                    else
                                    {
                                        if (!(nodehvinfo.empty()) && (nodehvinfo.size() >= 4))
                                        {
                                            if (nodehvinfo.front().locationID != nodehvinfo.back().locationID)
                                            {
                                                if (nodehvinfo.at(PD_LgtCrsLneIndx).RELAT_S < pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].end_offset &&
                                                    nodehvinfo.at(PD_LgtCrsLneIndx).RELAT_S > pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].start_offset /*&&
                                                    pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].end_offset < LaneEndRgeThrsVal*/
                                                )
                                                {
#ifdef GLOG
                                                    DLOG(INFO) << "Right Solide Line";
                                                    DLOG(INFO) << "Current time not Lane change"
                                                               << "\trm_id:(" << int(pd_input.rm_roadmodel.at(rm_Num).road_id.x) << "," << int(pd_input.rm_roadmodel.at(rm_Num).road_id.y) << ")" << std::endl;
                                                    DLOG(INFO) << "lgt_s: " << nodehvinfo.back().RELAT_S
                                                               << "\ttnode_1s_RELAT_S: " << nodehvinfo.at(PD_LgtCrsLneIndx).RELAT_S
                                                               << "\tlinetype: " << int(pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).line_type_attribute_list.at(typsz).linetype) << std::endl;

                                                    DLOG(INFO) << "\trm_Num: " << rm_Num
                                                               << "lnemksiz: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.size()
                                                               << "\ttypsz: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list.size()
                                                               << "\tlnemksz_indx: " << lnemksz
                                                               << "\ttypsz_indx: " << typsz << std::endl;

                                                    DLOG(INFO) << "end_offset: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).line_type_attribute_list.at(typsz).end_offset
                                                               << "\tstart_offset: " << pd_input.rm_roadmodel.at(rm_Num).lane_marker_list.at(lnemksz).line_type_attribute_list.at(typsz).start_offset << std::endl;
                                                    DLOG(INFO) << std::endl;
#endif
                                                    if (pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].linetype == 1 ||
                                                        pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].linetype == 3 ||
                                                        pd_input.rm_roadmodel.at(rm_Num).lane_marker_list[lnemksz].line_type_attribute_list[typsz].linetype == 5)
                                                    {
                                                        CrsSldLineClsnFlag = true;

                                                        break;
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }

                                break;
                            }
                        }
                    }
                }
            } // find ego lane id

            // consider real time target lane line c0

            DLOG(INFO) << "real CrsSLDLineClsnFlag: " << CrsSldLineClsnFlag;
            DLOG(INFO) << "ChgToTgtLaneID: " << int(ChgToTgtLaneID);
            if (ChgToTgtLaneID == pd_input.rm_roadmodel.at(rm_Num).lane_list[lane_indx].end_id)
            {
                DLOG(INFO) << "cor size: " << pd_input.rm_roadmodel.at(rm_Num).lane_list[lane_indx].corridor_list.size();

                if (!pd_input.rm_roadmodel.at(rm_Num).lane_list[lane_indx].corridor_list.empty() &&
                    fabs(pd_input.rm_roadmodel.at(rm_Num).lane_list[lane_indx].corridor_list.front().reference_line.c0) <= PD_NodeCrslineValC0)
                {
                    CrsSldLineClsnFlag = (false && CrsSldLineClsnFlag);
                    DLOG(INFO) << "test c0: " << pd_input.rm_roadmodel.at(rm_Num).lane_list[lane_indx].corridor_list.front().reference_line.c0;
                    DLOG(INFO) << "test CrsSldLineClsnFlag: " << CrsSldLineClsnFlag;
                }
            }
        } // lane list

        if (CrsSldLineClsnFlag == false)
        {
            LessLaneWidLeadClsn(pd_input);
            RoadEndLeadClsn(pd_input);
            // RoadEndLeadClsnProc(pd_input);
        }

    } // lane change
}

float ADC::PD_NodeUpdate::GetObjSizeWidth(const uint32_t &objid,
                                          const PD::PD_Input &pd_input)
{
    float temp_TargetObjSizeWid = 0.0f;
    // traverse all object
    for (int i = 0; i < pd_input.rm_roadmodel.at(rm_Num).object_list.size(); i++)
    {
        if (objid == pd_input.rm_roadmodel.at(rm_Num).object_list[i].object_id)
        {
            temp_TargetObjSizeWid = pd_input.rm_roadmodel.at(rm_Num).object_list[i].size_width;
        }
    }

    return temp_TargetObjSizeWid;
}

void NodeUpdate::NodeObjChkClsnProc()
/*
    lateral and longitudinal are risk within the prediction effective time
*/
{

    DLOG(INFO) << "**clsnobjinfo size: " << clsnobjinfo.size();
    if (!clsnobjinfo.empty())
    {

        for (auto iter = clsnobjinfo.begin(); iter != clsnobjinfo.end();)
        {
            for (int i = 0; i < PD_NodeObjStsVec.size(); i++)
            {

                if (iter->ClsnObjID == PD_NodeObjStsVec[i].m_ObjID && (PD_NodeObjStsVec[i].vec_l.size() >= PD_ChkClsn_timesize))
                {
                    // if (fabs(*min_element(PD_NodeObjStsVec[i].vec_relat_s.begin(), PD_NodeObjStsVec[i].vec_relat_s.end() - (PD_NodeObjStsVec[i].vec_relat_s.size() - PD_ChkClsn_timesize))) < PD_NodeLgtClsnRltvDist)
                    if (fabs(*min_element(PD_NodeObjStsVec[i].vec_relat_s.begin(), (PD_NodeObjStsVec[i].vec_relat_s.end() - PD_ChkClsn_timesize))) < (PD_NodeLgtClsnRltvDist + 4))
                    {
                        iter->ClsnFlag = true;
                    }
                    else
                    {
                        iter->ClsnFlag = false;
                    }
                }
#ifdef GLOG
                DLOG(INFO) << "**clsn id: " << PD_NodeObjStsVec[i].m_ObjID
                           << "\t**clsn vec_l size: " << PD_NodeObjStsVec[i].vec_l.size();
#endif
            }
            iter++;
        }
    }

    // clear clsnflag false reult in clsnobjinfo vector

    if (!clsnobjinfo.empty())
    {
        for (auto it = clsnobjinfo.begin(); it != clsnobjinfo.end();)
        {
            bool ClsnObj_IvalidFlag = false;

            if (it->ClsnFlag == false)
            {
                ClsnObj_IvalidFlag = true;
            }
            if (ClsnObj_IvalidFlag)
            {
                clsnobjinfo.erase(it);
            }
            else
            {
                it++;
            }
        }
    }
}

float NodeUpdate::GetNodeMinDist(std::vector<float> &pd_clsnobj)
{
    float Maxval = *max_element(pd_clsnobj.begin(), pd_clsnobj.end());
    float Minval = *min_element(pd_clsnobj.begin(), pd_clsnobj.end());
    float PDNode_MinDist = 999;
    if (Maxval * Minval > 0 && Maxval > 0)
    {
        PDNode_MinDist = Minval;
    }
    else if (Maxval * Minval > 0 && Maxval < 0)
    {
        PDNode_MinDist = Maxval;
    }
    else
    {
        PDNode_MinDist = 1.0;
    }

    return PDNode_MinDist;
}

bool NodeUpdate::NodeClsnStsCalu(const PD_SVEstmd::SVEstmd &svtrajpnt,
                                 const PD::PD_Input &pd_input,
                                 const PD_EgoVehTrj::EgoVehTrj &egovehtrj)
{
    // case 1:Collision due to dynamic object

    if (Init(egovehtrj, svtrajpnt) || (!egovehtrj.egoveh_tp.empty()))
    {
        PD_ClsnSVObj pd_clsnsvobj;
        // float PD_Nodelat2reflindist = 0.5f; // lateral threshold of longitudinal collision,unit:m

        std::vector<PD_ClsnSVObj> temp_PD_NodeObjStsVec;

        float TargetObjSizeWid = 0.0f;

        for (auto it = svtrajpnt.SV_Trajectory_list.begin(); it != svtrajpnt.SV_Trajectory_list.end();) // get sv number
        {
            bool ClsnRelatObjFlg = false;
            uint32_t objid = (*it).m_obj_ID;

            TargetObjSizeWid = ADC::PD_NodeUpdate::GetObjSizeWidth(objid, pd_input);
            // DLOG(INFO) << "half_egowid: " << 0.5 * EgoVheSizeWidth
            //            << "\tobjid: " << int(objid)
            //            << "\thalf_TargetobjWid: " << 0.5 * TargetObjSizeWid
            //            << std::endl;

            int sv_size = it->pd_ls_point_list.size();
            int ev_size = egovehtrj.egoveh_tp.size();
            int IntermNum = std::min(sv_size, ev_size);

            for (int i = 0; i < IntermNum; i++)
            {
                // DLOG(INFO) << std::endl;
                // DLOG(INFO) << "old_l: " << fabs(it->pd_ls_point_list[i].l)
                //            << "\tNew_l: " << fabs(it->pd_ls_point_list[i].l - egovehtrj.egoveh_tp[i].l) - 0.5 * EgoVheSizeWidth - 0.5 * TargetObjSizeWid
                //            << std::endl;
                if ((fabs(it->pd_ls_point_list[i].l - egovehtrj.egoveh_tp[i].l) - 0.5 * EgoVheSizeWidth - 0.5 * TargetObjSizeWid) <= PD_Nodelat2reflindist)
                {
                    ClsnRelatObjFlg = true;
                    break;
                }
            }

            if (ClsnRelatObjFlg == true)
            {
                pd_clsnsvobj.m_ObjID = (*it).m_obj_ID;
                for (int i = 0; i < (*it).pd_ls_point_list.size(); i++)
                {

                    pd_clsnsvobj.vec_l.emplace_back((*it).pd_ls_point_list[i].l);
                    pd_clsnsvobj.vec_relat_s.emplace_back((*it).pd_ls_point_list[i].s_relative);
                    pd_clsnsvobj.vec_vs.emplace_back((*it).pd_ls_point_list[i].vs);
                    temp_PD_NodeObjStsVec.emplace_back(pd_clsnsvobj);
                }
                pd_clsnsvobj.vec_l.clear();
                pd_clsnsvobj.vec_relat_s.clear();
                pd_clsnsvobj.vec_vs.clear();

                PD_NodeObjStsVec.emplace_back(temp_PD_NodeObjStsVec.back()); // fill with latrisk object
            }

            temp_PD_NodeObjStsVec.clear();
            it++;
        }

        if (PD_NodeObjStsVec.size() >= static_cast<int>(1))
        {
// analysis data
#ifdef GLOG
            DLOG(INFO) << "before_latrisknum: " << PD_NodeObjStsVec.size() << std::endl;
            for (auto ele : PD_NodeObjStsVec)
            {
                DLOG(INFO) << "before_obj_id: " << ele.m_ObjID << std::endl;
            }
#endif

            // add sourrding vechiel initial l constraints
            for (auto iter = PD_NodeObjStsVec.begin(); iter != PD_NodeObjStsVec.end();)
            {
                //     // check sv initial l position
                bool temp_Flg = false;
                for (int i = 0; i < iter->vec_l.size(); i++)
                {
                    if (fabs(iter->vec_l.front()) >= SVInitalFrnt_L)
                    {
                        temp_Flg = true;
                        break;
                    }
                }
                if (temp_Flg == true)
                    PD_NodeObjStsVec.erase(iter);
                else
                    iter++;
            }
        }

        // DLOG(INFO) <<
        if (!PD_NodeObjStsVec.empty())
        {
// analysis data
#ifdef GLOG
            DLOG(INFO) << "after_latrisknum: " << PD_NodeObjStsVec.size() << std::endl;
            for (auto ele : PD_NodeObjStsVec)
            {
                DLOG(INFO) << "after_obj_id: " << ele.m_ObjID << std::endl;
            }
#endif

            uint32_t RiskObjID = 0;

            for (int RltvObj_idx = 0; RltvObj_idx < PD_NodeObjStsVec.size(); RltvObj_idx++) // relative object number
            {
                ClsnObjInfo m_clsnobj;
                float spdval = 1.0f;
                DLOG(INFO) << std::endl;
                DLOG(INFO) << "id: " << int(PD_NodeObjStsVec[RltvObj_idx].m_ObjID)
                           << "\tmin dist: " << fabs(*min_element(PD_NodeObjStsVec.at(RltvObj_idx).vec_relat_s.begin(), PD_NodeObjStsVec.at(RltvObj_idx).vec_relat_s.end()))
                           << "\t01min dist: " << fabs(GetNodeMinDist(PD_NodeObjStsVec[RltvObj_idx].vec_relat_s));
                DLOG(INFO) << std::endl;
                // Min_NodeObjRelat_s

                if (fabs(GetNodeMinDist(PD_NodeObjStsVec[RltvObj_idx].vec_relat_s)) < (PD_NodeLgtClsnRltvDist + 4.0) &&
                    (pd_input.VSE_LgtVehSpd - PD_NodeObjStsVec[RltvObj_idx].vec_vs.front() >= spdval) &&
                    (PD_NodeObjStsVec[RltvObj_idx].vec_relat_s.front() > 0))
                // if (fabs(GetNodeMinDist(PD_NodeObjStsVec[RltvObj_idx].vec_relat_s)) < (PD_NodeLgtClsnRltvDist + 4.0))

                {
                    NodeClsnFlag = true;
                    RiskObjID = PD_NodeObjStsVec.at(RltvObj_idx).m_ObjID;

                    m_clsnobj.ClsnFlag = true;
                    m_clsnobj.ClsnObjID = PD_NodeObjStsVec.at(RltvObj_idx).m_ObjID;

                    clsnobjinfo.emplace_back(m_clsnobj); // fill with risk object
                }
            }
            DLOG(INFO) << "01clsnobjinfo size: " << clsnobjinfo.size();
#ifdef GLOG
            // analysis dangerous obj 20220630
            // if (!clsnobjinfo.empty())
            if (!PD_NodeObjStsVec.empty())
            {
                DLOG(INFO) << "ClsnObjInfo" << std::endl;
                DLOG(INFO) << "ClsnObjNum: " << clsnobjinfo.size() << std::endl;
                for (auto it = clsnobjinfo.begin(); it != clsnobjinfo.end();)
                {
                    for (int k = 0; k < PD_NodeObjStsVec.size(); k++)
                    {
                        if (it->ClsnObjID == PD_NodeObjStsVec[k].m_ObjID)
                        {
                            DLOG(INFO) << "clsnobj_id: " << it->ClsnObjID << std::endl;
                            for (int m = 0; m < PD_NodeObjStsVec[k].vec_l.size(); m++)
                            {
                                DLOG(INFO) << "clsnobj_s: " << PD_NodeObjStsVec[k].vec_relat_s[m]
                                           << "\tclsnobj_l: " << PD_NodeObjStsVec[k].vec_l[m]
                                           << "\tclsnobj_relat_L: " << fabs(PD_NodeObjStsVec[k].vec_l[m] - egovehtrj.egoveh_tp[m].l) - 0.5 * EgoVheSizeWidth - 0.5 * TargetObjSizeWid
                                           << "\tclsnobj_vx: " << PD_NodeObjStsVec[k].vec_vs[m] << std::endl;
                            }
                        }
                    }
                    it++;
                }
            }
#endif
        }

        StnEnvLeadClsn(pd_input);
        // std::cout << "001" << std::endl;
    } // dynamic object lead to clsn
    else
    {
        NodeClsnFlag = false;
    }

    NodeObjChkClsnProc(); // to process same space-time dimension clsnflg

    DLOG(INFO) << "clsninfo res: " << clsnobjinfo.size();
    if (!clsnobjinfo.empty())
    {
        NodeClsnFlag = true;
    }
    else
    {
        NodeClsnFlag = false;
    }

    // seperate object collision from nodeclsnsts 20220927
    NodeClsnFlag = false;  

    bool analysis_clsnflg = false; // to analysis dynamic object risk
    analysis_clsnflg = NodeClsnFlag;

    NodeClsnFlag = NodeClsnFlag || LaneChgClsnFlag;

    NodeClsnFlag = NodeClsnFlag || CrsSldLineClsnFlag;

    NodeClsnFlag = NodeClsnFlag || InsfcntLaneWidClsnFlag;

    NodeClsnFlag = NodeClsnFlag || RdEndClsnFlag;

    NodeClsnFlag = NodeClsnFlag || CrsLaneClsnFlag;
#ifdef GLOG
    DLOG(INFO) << "LaneChgClsnFlag: " << LaneChgClsnFlag
               << "\tCrsSldLineClsnFlag: " << CrsSldLineClsnFlag
               << "\tInsfcntLaneWidClsnFlag: " << InsfcntLaneWidClsnFlag << std::endl;
    DLOG(INFO) << "RdEndClsnFlag: " << RdEndClsnFlag
               << "\tCrsLaneClsnFlag: " << CrsLaneClsnFlag
               << "\tNodeClsnFlag: " << NodeClsnFlag << "\tpsg_action: " << int(pd_input.rm_roadmodel.at(rm_Num).passage_list.at(psg_Num).action_type) << std::endl;
#endif
    return NodeClsnFlag;
}